package cn.axzo.workflow.server.controller.delegate;

import cn.axzo.maokai.api.client.OrganizationalNodeUserApi;
import cn.axzo.maokai.api.vo.request.FlowTaskAssignerReq;
import cn.axzo.maokai.api.vo.response.FlowTaskAssigner;
import cn.axzo.workflow.common.enums.ApproverSpecifyEnum;
import cn.axzo.workflow.common.model.request.bpmn.task.BpmnTaskDelegateAssigner;
import cn.axzo.workflow.core.deletage.approverscope.ApproverScopeDTO;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.ListUtils;
import org.flowable.bpmn.model.FlowElement;
import org.flowable.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

/**
 * 基于"岗位"查询审批人
 *
 * @author wangli
 * @since 2023/11/16 11:35
 */
@Slf4j
@Component
public class BasedPositionTaskAssigneeSelector extends AbstractBpmnTaskAssigneeSelector {

    @Autowired
    private OrganizationalNodeUserApi organizationalNodeUserApi;

    @Override
    public String getType() {
        return ApproverSpecifyEnum.position.getType();
    }

    @Override
    public boolean support(String param) {
        return getType().equals(param);
    }

    @Override
    public List<BpmnTaskDelegateAssigner> select(FlowElement flowElement, DelegateExecution execution,
                                                 Boolean throwException) {
        return super.select(flowElement, execution, throwException);
    }

    @Override
    protected List<BpmnTaskDelegateAssigner> invokeService(FlowElement flowElement, DelegateExecution execution,
                                                           ApproverScopeDTO scopeDto) {
        FlowTaskAssignerReq req = FlowTaskAssignerReq.builder()
                .orgScopes(ListUtils.emptyIfNull(scopeDto.getOrgScopes()).stream()
                        .map(e -> BeanUtil.copyProperties(e, FlowTaskAssignerReq.OrgScope.class))
                        .collect(Collectors.toList()))
                .jobCodes(super.getTypes(flowElement))
                .build();

        List<FlowTaskAssignerReq.OrgScope> workerTeamScopes = ListUtils.emptyIfNull(scopeDto.getWorkerTeamScopes()).stream()
                .map(e -> BeanUtil.copyProperties(e, FlowTaskAssignerReq.OrgScope.class)).collect(Collectors.toList());
        req.getOrgScopes().addAll(workerTeamScopes);

        List<FlowTaskAssigner> flowTaskAssigners =
                parseApiResult(() -> organizationalNodeUserApi.listFlowTaskAssigner(req),
                        "审批节点: " + flowElement.getId() + ", 通过岗位查询审批人",
                        "cn.axzo.maokai.api.client.OrganizationalNodeUserApi.listFlowTaskAssigner", req);

        if (CollUtil.isEmpty(flowTaskAssigners)) {
            return super.invokeService(flowElement, execution, scopeDto);
        }
        return BeanUtil.copyToList(flowTaskAssigners, BpmnTaskDelegateAssigner.class);
    }
}
